// Ultima IV (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>

#include "d88.h"
#include <string.h>

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _offset + _size);
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{

	unsigned char id[] = "Ultima IV    Sys ";
	char fname[FILENAME_MAX];
	int i,d;

	//	ȃf[^̈ʒu
	struct fpos md[] =
	{
		{ 0x3d, 0x09, 0x0500 },	// #00
		{ 0x3e, 0x01, 0x0800 },	// #01
		{ 0x3e, 0x09, 0x0800 },	// #02
		{ 0x3f, 0x01, 0x0800 },	// #03
		{ 0x3f, 0x09, 0x0800 },	// #04
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};            

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	disk.SetRecordRange(0x01,0x010);
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);
		if (!memcmp(&buff[1],id,sizeof(id)-1))
		{
			printf("Ultima Disk F܂.\n");
			fcut("PROG",   0x04, 0x02, 0x00, 0x01, 0x01, 0x0000, 0xb000);
			fcut("DRIVER", 0x33, 0x19, 0x01, 0x0a, 0x01, 0x0000, 0x0600);
			for (i=0; md[i].sec; i++)
			{
				sprintf(fname,"MUS%02d",i);
				fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, md[i].size);
			}
		}
	}
	return 0;
}

